
//
// Auto generated file by CMake macros cross_compiled_file()
// !! do not modify it !!!
//
#include "/builddir/build/BUILD/openvino-2025.1.0-build/openvino-2025.1.0/src/plugins/intel_cpu/src/nodes/kernels/scaled_attn/attn_memcpy.hpp"
#include "openvino/runtime/system_conf.hpp"

namespace ov {
namespace Extensions {
namespace Cpu {
namespace AVX512F {
    void attn_memcpy(const ov::intel_cpu::PlainTensor& k_input,
                 const ov::intel_cpu::PlainTensor& v_input,
                 const ov::intel_cpu::PlainTensor& past_k_output,
                 const ov::intel_cpu::PlainTensor& past_v_output); 
}
namespace AVX2 {
    void attn_memcpy(const ov::intel_cpu::PlainTensor& k_input,
                 const ov::intel_cpu::PlainTensor& v_input,
                 const ov::intel_cpu::PlainTensor& past_k_output,
                 const ov::intel_cpu::PlainTensor& past_v_output); 
}
namespace ANY {
    void attn_memcpy(const ov::intel_cpu::PlainTensor& k_input,
                 const ov::intel_cpu::PlainTensor& v_input,
                 const ov::intel_cpu::PlainTensor& past_k_output,
                 const ov::intel_cpu::PlainTensor& past_v_output); 
}
namespace XARCH {

void attn_memcpy(const ov::intel_cpu::PlainTensor& k_input,
                 const ov::intel_cpu::PlainTensor& v_input,
                 const ov::intel_cpu::PlainTensor& past_k_output,
                 const ov::intel_cpu::PlainTensor& past_v_output) {
    if (with_cpu_x86_avx512f()) {
        return AVX512F::attn_memcpy(k_input, v_input, past_k_output, past_v_output);
    }
    if (with_cpu_x86_avx2()) {
        return AVX2::attn_memcpy(k_input, v_input, past_k_output, past_v_output);
    }
    if (true) {
        return ANY::attn_memcpy(k_input, v_input, past_k_output, past_v_output);
    }
}

}
namespace AVX512F {
    void paged_attn_memcpy(const ov::intel_cpu::PlainTensor& k_input,
                       const ov::intel_cpu::PlainTensor& v_input,
                       const ov::intel_cpu::PlainTensor& past_k_output,
                       const ov::intel_cpu::PlainTensor& past_v_output,
                       const ov::intel_cpu::PlainTensor& slot_mapping); 
}
namespace AVX2 {
    void paged_attn_memcpy(const ov::intel_cpu::PlainTensor& k_input,
                       const ov::intel_cpu::PlainTensor& v_input,
                       const ov::intel_cpu::PlainTensor& past_k_output,
                       const ov::intel_cpu::PlainTensor& past_v_output,
                       const ov::intel_cpu::PlainTensor& slot_mapping); 
}
namespace ANY {
    void paged_attn_memcpy(const ov::intel_cpu::PlainTensor& k_input,
                       const ov::intel_cpu::PlainTensor& v_input,
                       const ov::intel_cpu::PlainTensor& past_k_output,
                       const ov::intel_cpu::PlainTensor& past_v_output,
                       const ov::intel_cpu::PlainTensor& slot_mapping); 
}
namespace XARCH {

void paged_attn_memcpy(const ov::intel_cpu::PlainTensor& k_input,
                       const ov::intel_cpu::PlainTensor& v_input,
                       const ov::intel_cpu::PlainTensor& past_k_output,
                       const ov::intel_cpu::PlainTensor& past_v_output,
                       const ov::intel_cpu::PlainTensor& slot_mapping) {
    if (with_cpu_x86_avx512f()) {
        return AVX512F::paged_attn_memcpy(k_input, v_input, past_k_output, past_v_output, slot_mapping);
    }
    if (with_cpu_x86_avx2()) {
        return AVX2::paged_attn_memcpy(k_input, v_input, past_k_output, past_v_output, slot_mapping);
    }
    if (true) {
        return ANY::paged_attn_memcpy(k_input, v_input, past_k_output, past_v_output, slot_mapping);
    }
}

}
namespace AVX512F {
    void attn_memcpy2d_kernel(void* src,
                          void* dst,
                          ov::element::Type src_type,
                          ov::element::Type dst_type,
                          size_t src_stride,
                          size_t dst_stride,
                          size_t width,
                          size_t height); 
}
namespace AVX2 {
    void attn_memcpy2d_kernel(void* src,
                          void* dst,
                          ov::element::Type src_type,
                          ov::element::Type dst_type,
                          size_t src_stride,
                          size_t dst_stride,
                          size_t width,
                          size_t height); 
}
namespace ANY {
    void attn_memcpy2d_kernel(void* src,
                          void* dst,
                          ov::element::Type src_type,
                          ov::element::Type dst_type,
                          size_t src_stride,
                          size_t dst_stride,
                          size_t width,
                          size_t height); 
}
namespace XARCH {

void attn_memcpy2d_kernel(void* src,
                          void* dst,
                          ov::element::Type src_type,
                          ov::element::Type dst_type,
                          size_t src_stride,
                          size_t dst_stride,
                          size_t width,
                          size_t height) {
    if (with_cpu_x86_avx512f()) {
        return AVX512F::attn_memcpy2d_kernel(src, dst, src_type, dst_type, src_stride, dst_stride, width, height);
    }
    if (with_cpu_x86_avx2()) {
        return AVX2::attn_memcpy2d_kernel(src, dst, src_type, dst_type, src_stride, dst_stride, width, height);
    }
    if (true) {
        return ANY::attn_memcpy2d_kernel(src, dst, src_type, dst_type, src_stride, dst_stride, width, height);
    }
}

}
}  // namespace ov
}  // namespace Extensions
}  // namespace Cpu
