
//
// Auto generated file by CMake macros cross_compiled_file()
// !! do not modify it !!!
//
#include "/builddir/build/BUILD/openvino-2025.1.0-build/openvino-2025.1.0/src/plugins/intel_cpu/src/nodes/kernels/scaled_attn/attn_quant.hpp"
#include "openvino/runtime/system_conf.hpp"

namespace ov {
namespace Extensions {
namespace Cpu {
namespace AVX512F {
    void attn_quantkv(const ov::intel_cpu::PlainTensor& k_src,
                  const ov::intel_cpu::PlainTensor& v_src,
                  float* temp_buffer,
                  const ov::intel_cpu::PlainTensor& k_dst,
                  const ov::intel_cpu::PlainTensor& v_dst,
                  const ov::intel_cpu::PlainTensor& k_scale_zp,
                  const ov::intel_cpu::PlainTensor& v_scale_zp,
                  const size_t L0,
                  const bool quant_k_by_channel,
                  const size_t k_group_size,
                  const size_t v_group_size); 
}
namespace AVX2 {
    void attn_quantkv(const ov::intel_cpu::PlainTensor& k_src,
                  const ov::intel_cpu::PlainTensor& v_src,
                  float* temp_buffer,
                  const ov::intel_cpu::PlainTensor& k_dst,
                  const ov::intel_cpu::PlainTensor& v_dst,
                  const ov::intel_cpu::PlainTensor& k_scale_zp,
                  const ov::intel_cpu::PlainTensor& v_scale_zp,
                  const size_t L0,
                  const bool quant_k_by_channel,
                  const size_t k_group_size,
                  const size_t v_group_size); 
}
namespace ANY {
    void attn_quantkv(const ov::intel_cpu::PlainTensor& k_src,
                  const ov::intel_cpu::PlainTensor& v_src,
                  float* temp_buffer,
                  const ov::intel_cpu::PlainTensor& k_dst,
                  const ov::intel_cpu::PlainTensor& v_dst,
                  const ov::intel_cpu::PlainTensor& k_scale_zp,
                  const ov::intel_cpu::PlainTensor& v_scale_zp,
                  const size_t L0,
                  const bool quant_k_by_channel,
                  const size_t k_group_size,
                  const size_t v_group_size); 
}
namespace XARCH {

void attn_quantkv(const ov::intel_cpu::PlainTensor& k_src,
                  const ov::intel_cpu::PlainTensor& v_src,
                  float* temp_buffer,
                  const ov::intel_cpu::PlainTensor& k_dst,
                  const ov::intel_cpu::PlainTensor& v_dst,
                  const ov::intel_cpu::PlainTensor& k_scale_zp,
                  const ov::intel_cpu::PlainTensor& v_scale_zp,
                  const size_t L0,
                  const bool quant_k_by_channel,
                  const size_t k_group_size,
                  const size_t v_group_size) {
    if (with_cpu_x86_avx512f()) {
        return AVX512F::attn_quantkv(k_src, v_src, temp_buffer, k_dst, v_dst, k_scale_zp, v_scale_zp, L0, quant_k_by_channel, k_group_size, v_group_size);
    }
    if (with_cpu_x86_avx2()) {
        return AVX2::attn_quantkv(k_src, v_src, temp_buffer, k_dst, v_dst, k_scale_zp, v_scale_zp, L0, quant_k_by_channel, k_group_size, v_group_size);
    }
    if (true) {
        return ANY::attn_quantkv(k_src, v_src, temp_buffer, k_dst, v_dst, k_scale_zp, v_scale_zp, L0, quant_k_by_channel, k_group_size, v_group_size);
    }
}

}
namespace AVX512F {
    void paged_attn_quantkv(const ov::intel_cpu::PlainTensor& k_src,
                        const ov::intel_cpu::PlainTensor& v_src,
                        const ov::intel_cpu::PlainTensor& k_dst,
                        const ov::intel_cpu::PlainTensor& v_dst,
                        const ov::intel_cpu::PlainTensor& past_lens,
                        const ov::intel_cpu::PlainTensor& subsequence_begins,
                        const ov::intel_cpu::PlainTensor& block_indices,
                        const ov::intel_cpu::PlainTensor& block_indices_begins,
                        const ov::intel_cpu::PlainTensor& slot_mapping,
                        ov::intel_cpu::PlainTensor& temp_buffer,
                        const bool quant_key_by_channel,
                        const size_t key_group_size,
                        const size_t value_group_size); 
}
namespace AVX2 {
    void paged_attn_quantkv(const ov::intel_cpu::PlainTensor& k_src,
                        const ov::intel_cpu::PlainTensor& v_src,
                        const ov::intel_cpu::PlainTensor& k_dst,
                        const ov::intel_cpu::PlainTensor& v_dst,
                        const ov::intel_cpu::PlainTensor& past_lens,
                        const ov::intel_cpu::PlainTensor& subsequence_begins,
                        const ov::intel_cpu::PlainTensor& block_indices,
                        const ov::intel_cpu::PlainTensor& block_indices_begins,
                        const ov::intel_cpu::PlainTensor& slot_mapping,
                        ov::intel_cpu::PlainTensor& temp_buffer,
                        const bool quant_key_by_channel,
                        const size_t key_group_size,
                        const size_t value_group_size); 
}
namespace ANY {
    void paged_attn_quantkv(const ov::intel_cpu::PlainTensor& k_src,
                        const ov::intel_cpu::PlainTensor& v_src,
                        const ov::intel_cpu::PlainTensor& k_dst,
                        const ov::intel_cpu::PlainTensor& v_dst,
                        const ov::intel_cpu::PlainTensor& past_lens,
                        const ov::intel_cpu::PlainTensor& subsequence_begins,
                        const ov::intel_cpu::PlainTensor& block_indices,
                        const ov::intel_cpu::PlainTensor& block_indices_begins,
                        const ov::intel_cpu::PlainTensor& slot_mapping,
                        ov::intel_cpu::PlainTensor& temp_buffer,
                        const bool quant_key_by_channel,
                        const size_t key_group_size,
                        const size_t value_group_size); 
}
namespace XARCH {

void paged_attn_quantkv(const ov::intel_cpu::PlainTensor& k_src,
                        const ov::intel_cpu::PlainTensor& v_src,
                        const ov::intel_cpu::PlainTensor& k_dst,
                        const ov::intel_cpu::PlainTensor& v_dst,
                        const ov::intel_cpu::PlainTensor& past_lens,
                        const ov::intel_cpu::PlainTensor& subsequence_begins,
                        const ov::intel_cpu::PlainTensor& block_indices,
                        const ov::intel_cpu::PlainTensor& block_indices_begins,
                        const ov::intel_cpu::PlainTensor& slot_mapping,
                        ov::intel_cpu::PlainTensor& temp_buffer,
                        const bool quant_key_by_channel,
                        const size_t key_group_size,
                        const size_t value_group_size) {
    if (with_cpu_x86_avx512f()) {
        return AVX512F::paged_attn_quantkv(k_src, v_src, k_dst, v_dst, past_lens, subsequence_begins, block_indices, block_indices_begins, slot_mapping, temp_buffer, quant_key_by_channel, key_group_size, value_group_size);
    }
    if (with_cpu_x86_avx2()) {
        return AVX2::paged_attn_quantkv(k_src, v_src, k_dst, v_dst, past_lens, subsequence_begins, block_indices, block_indices_begins, slot_mapping, temp_buffer, quant_key_by_channel, key_group_size, value_group_size);
    }
    if (true) {
        return ANY::paged_attn_quantkv(k_src, v_src, k_dst, v_dst, past_lens, subsequence_begins, block_indices, block_indices_begins, slot_mapping, temp_buffer, quant_key_by_channel, key_group_size, value_group_size);
    }
}

}
namespace AVX512F {
    void attn_quant_u8(const float* src, uint8_t* dst, size_t n, float& scale, float& zp); 
}
namespace AVX2 {
    void attn_quant_u8(const float* src, uint8_t* dst, size_t n, float& scale, float& zp); 
}
namespace ANY {
    void attn_quant_u8(const float* src, uint8_t* dst, size_t n, float& scale, float& zp); 
}
namespace XARCH {

void attn_quant_u8(const float* src, uint8_t* dst, size_t n, float& scale, float& zp) {
    if (with_cpu_x86_avx512f()) {
        return AVX512F::attn_quant_u8(src, dst, n, scale, zp);
    }
    if (with_cpu_x86_avx2()) {
        return AVX2::attn_quant_u8(src, dst, n, scale, zp);
    }
    if (true) {
        return ANY::attn_quant_u8(src, dst, n, scale, zp);
    }
}

}
namespace AVX512F {
    void attn_dequant_u8(const uint8_t* src, float* dst, size_t n, float scale, float zp); 
}
namespace AVX2 {
    void attn_dequant_u8(const uint8_t* src, float* dst, size_t n, float scale, float zp); 
}
namespace ANY {
    void attn_dequant_u8(const uint8_t* src, float* dst, size_t n, float scale, float zp); 
}
namespace XARCH {

void attn_dequant_u8(const uint8_t* src, float* dst, size_t n, float scale, float zp) {
    if (with_cpu_x86_avx512f()) {
        return AVX512F::attn_dequant_u8(src, dst, n, scale, zp);
    }
    if (with_cpu_x86_avx2()) {
        return AVX2::attn_dequant_u8(src, dst, n, scale, zp);
    }
    if (true) {
        return ANY::attn_dequant_u8(src, dst, n, scale, zp);
    }
}

}
namespace AVX512F {
    void attn_quant_by_channel_u8(const float* src,
                              uint8_t* dst,
                              size_t seq_dim,
                              size_t hidden_dims,
                              size_t src_stride,
                              size_t dst_stride,
                              float* scale,
                              float* zp); 
}
namespace AVX2 {
    void attn_quant_by_channel_u8(const float* src,
                              uint8_t* dst,
                              size_t seq_dim,
                              size_t hidden_dims,
                              size_t src_stride,
                              size_t dst_stride,
                              float* scale,
                              float* zp); 
}
namespace ANY {
    void attn_quant_by_channel_u8(const float* src,
                              uint8_t* dst,
                              size_t seq_dim,
                              size_t hidden_dims,
                              size_t src_stride,
                              size_t dst_stride,
                              float* scale,
                              float* zp); 
}
namespace XARCH {

void attn_quant_by_channel_u8(const float* src,
                              uint8_t* dst,
                              size_t seq_dim,
                              size_t hidden_dims,
                              size_t src_stride,
                              size_t dst_stride,
                              float* scale,
                              float* zp) {
    if (with_cpu_x86_avx512f()) {
        return AVX512F::attn_quant_by_channel_u8(src, dst, seq_dim, hidden_dims, src_stride, dst_stride, scale, zp);
    }
    if (with_cpu_x86_avx2()) {
        return AVX2::attn_quant_by_channel_u8(src, dst, seq_dim, hidden_dims, src_stride, dst_stride, scale, zp);
    }
    if (true) {
        return ANY::attn_quant_by_channel_u8(src, dst, seq_dim, hidden_dims, src_stride, dst_stride, scale, zp);
    }
}

}
namespace AVX512F {
    void attn_dequant_by_channel_u8(const uint8_t* src,
                                float* dst,
                                size_t seq_dim,
                                size_t hidden_dims,
                                size_t src_stride,
                                size_t dst_stride,
                                float* scale,
                                float* zp); 
}
namespace AVX2 {
    void attn_dequant_by_channel_u8(const uint8_t* src,
                                float* dst,
                                size_t seq_dim,
                                size_t hidden_dims,
                                size_t src_stride,
                                size_t dst_stride,
                                float* scale,
                                float* zp); 
}
namespace ANY {
    void attn_dequant_by_channel_u8(const uint8_t* src,
                                float* dst,
                                size_t seq_dim,
                                size_t hidden_dims,
                                size_t src_stride,
                                size_t dst_stride,
                                float* scale,
                                float* zp); 
}
namespace XARCH {

void attn_dequant_by_channel_u8(const uint8_t* src,
                                float* dst,
                                size_t seq_dim,
                                size_t hidden_dims,
                                size_t src_stride,
                                size_t dst_stride,
                                float* scale,
                                float* zp) {
    if (with_cpu_x86_avx512f()) {
        return AVX512F::attn_dequant_by_channel_u8(src, dst, seq_dim, hidden_dims, src_stride, dst_stride, scale, zp);
    }
    if (with_cpu_x86_avx2()) {
        return AVX2::attn_dequant_by_channel_u8(src, dst, seq_dim, hidden_dims, src_stride, dst_stride, scale, zp);
    }
    if (true) {
        return ANY::attn_dequant_by_channel_u8(src, dst, seq_dim, hidden_dims, src_stride, dst_stride, scale, zp);
    }
}

}
}  // namespace ov
}  // namespace Extensions
}  // namespace Cpu
